Package icyllis.modernui.widget

# Class CoordinatorLayout

java.lang.Object
icyllis.modernui.view.View
icyllis.modernui.view.ViewGroup
icyllis.modernui.widget.CoordinatorLayout

All Implemented Interfaces:
  `Drawable.Callback`, `ViewManager`, `ViewParent`

public class CoordinatorLayout extends ViewGroup
CoordinatorLayout is a super-powered `FrameLayout`.

CoordinatorLayout is intended for two primary use cases:

1. As a top-level application decor or chrome layout
2. As a container for a specific interaction with one or more child views

By specifying `Behaviors` for child views of a CoordinatorLayout you can provide many different interactions within a single parent and those views can also interact with one another. View classes can specify a default behavior when used as a child of a CoordinatorLayout by implementing the `CoordinatorLayout.AttachedBehavior` interface.

Behaviors may be used to implement a variety of interactions and additional layout modifications ranging from sliding drawers and panels to swipe-dismissable elements and buttons that stick to other elements as they move and animate.

Children of a CoordinatorLayout may have an `anchor`. This view id must correspond to an arbitrary descendant of the CoordinatorLayout, but it may not be the anchored child itself or a descendant of the anchored child. This can be used to place floating views relative to other arbitrary content panes.

Children can specify `CoordinatorLayout.LayoutParams.insetEdge` to describe how the view insets the CoordinatorLayout. Any child views which are set to dodge the same inset edges by `CoordinatorLayout.LayoutParams.dodgeInsetEdges` will be moved appropriately so that the views do not overlap.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `CoordinatorLayout.AttachedBehavior`
  Defines the default attached `CoordinatorLayout.Behavior` of a `View` class
  `static class`
  `CoordinatorLayout.Behavior<V extends View>`
  Interaction behavior plugin for child views of `CoordinatorLayout`.
  `static @interface`
  `CoordinatorLayout.DispatchChangeEvent`
  `static class`
  `CoordinatorLayout.LayoutParams`
  Parameters describing the desired layout for a child of a `CoordinatorLayout`.

  ## Nested classes/interfaces inherited from class icyllis.modernui.view.ViewGroup

  `ViewGroup.MarginLayoutParams`

  ## Nested classes/interfaces inherited from class icyllis.modernui.view.View

  `View.DragShadow, View.Focusable, View.FocusableMode, View.FocusDirection, View.FocusRealDirection, View.LayoutDir, View.NestedScrollType, View.OnAttachStateChangeListener, View.OnClickListener, View.OnContextClickListener, View.OnCreateContextMenuListener, View.OnDragListener, View.OnFocusChangeListener, View.OnGenericMotionListener, View.OnHoverListener, View.OnKeyListener, View.OnLayoutChangeListener, View.OnLongClickListener, View.OnScrollChangeListener, View.OnTouchListener, View.ResolvedLayoutDir, View.ScrollAxis, View.ScrollBarStyle, View.ScrollIndicators, View.TextAlignment, View.Visibility`

- ## Field Summary

  ### Fields inherited from class icyllis.modernui.view.ViewGroup

  `CLIP_TO_PADDING_MASK, FLAG_DISALLOW_INTERCEPT, FOCUS_AFTER_DESCENDANTS, FOCUS_BEFORE_DESCENDANTS, FOCUS_BLOCK_DESCENDANTS`

  ### Fields inherited from class icyllis.modernui.view.View

  `ALPHA, BOTTOM, EMPTY_STATE_SET, ENABLED_FOCUSED_SELECTED_STATE_SET, ENABLED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, ENABLED_FOCUSED_STATE_SET, ENABLED_FOCUSED_WINDOW_FOCUSED_STATE_SET, ENABLED_SELECTED_STATE_SET, ENABLED_SELECTED_WINDOW_FOCUSED_STATE_SET, ENABLED_STATE_SET, ENABLED_WINDOW_FOCUSED_STATE_SET, FOCUS_BACKWARD, FOCUS_DOWN, FOCUS_FORWARD, FOCUS_LEFT, FOCUS_RIGHT, FOCUS_UP, FOCUSABLE, FOCUSABLE_AUTO, FOCUSABLES_ALL, FOCUSABLES_TOUCH_MODE, FOCUSED_SELECTED_STATE_SET, FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, FOCUSED_STATE_SET, FOCUSED_WINDOW_FOCUSED_STATE_SET, GONE, HAPTIC_FEEDBACK_ENABLED, INVISIBLE, LAYOUT_DIRECTION_INHERIT, LAYOUT_DIRECTION_LOCALE, LAYOUT_DIRECTION_LTR, LAYOUT_DIRECTION_RTL, LAYOUT_DIRECTION_UNDEFINED, LEFT, MEASURED_HEIGHT_STATE_SHIFT, MEASURED_SIZE_MASK, MEASURED_STATE_MASK, MEASURED_STATE_TOO_SMALL, mPaddingBottom, mPaddingLeft, mPaddingRight, mPaddingTop, mScrollX, mScrollY, NO_ID, NOT_FOCUSABLE, OVER_SCROLL_ALWAYS, OVER_SCROLL_IF_CONTENT_SCROLLS, OVER_SCROLL_NEVER, PRESSED_ENABLED_FOCUSED_SELECTED_STATE_SET, PRESSED_ENABLED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_FOCUSED_STATE_SET, PRESSED_ENABLED_FOCUSED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_SELECTED_STATE_SET, PRESSED_ENABLED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_STATE_SET, PRESSED_ENABLED_WINDOW_FOCUSED_STATE_SET, PRESSED_FOCUSED_SELECTED_STATE_SET, PRESSED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_FOCUSED_STATE_SET, PRESSED_FOCUSED_WINDOW_FOCUSED_STATE_SET, PRESSED_SELECTED_STATE_SET, PRESSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_STATE_SET, PRESSED_WINDOW_FOCUSED_STATE_SET, RIGHT, ROTATION, ROTATION_X, ROTATION_Y, SCALE_X, SCALE_Y, SCROLL_AXIS_HORIZONTAL, SCROLL_AXIS_NONE, SCROLL_AXIS_VERTICAL, SCROLL_INDICATOR_BOTTOM, SCROLL_INDICATOR_END, SCROLL_INDICATOR_LEFT, SCROLL_INDICATOR_RIGHT, SCROLL_INDICATOR_START, SCROLL_INDICATOR_TOP, SCROLL_X, SCROLL_Y, SCROLLBARS_INSIDE_INSET, SCROLLBARS_INSIDE_OVERLAY, SCROLLBARS_OUTSIDE_INSET, SCROLLBARS_OUTSIDE_OVERLAY, SELECTED_STATE_SET, SELECTED_WINDOW_FOCUSED_STATE_SET, SOUND_EFFECTS_ENABLED, TEXT_ALIGNMENT_CENTER, TEXT_ALIGNMENT_GRAVITY, TEXT_ALIGNMENT_INHERIT, TEXT_ALIGNMENT_TEXT_END, TEXT_ALIGNMENT_TEXT_START, TEXT_ALIGNMENT_VIEW_END, TEXT_ALIGNMENT_VIEW_START, TEXT_DIRECTION_ANY_RTL, TEXT_DIRECTION_FIRST_STRONG, TEXT_DIRECTION_FIRST_STRONG_LTR, TEXT_DIRECTION_FIRST_STRONG_RTL, TEXT_DIRECTION_INHERIT, TEXT_DIRECTION_LOCALE, TEXT_DIRECTION_LTR, TEXT_DIRECTION_RTL, TOP, TRANSLATION_X, TRANSLATION_Y, TRANSLATION_Z, TYPE_NON_TOUCH, TYPE_TOUCH, VIEW_MARKER, VISIBLE, WINDOW_FOCUSED_STATE_SET, X, Y, Z`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CoordinatorLayout(Context context)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected boolean`
  `checkLayoutParams(ViewGroup.LayoutParams p)`
  Check whether given params fit to this view group.
  `void`
  `dispatchDependentViewsChanged(View view)`
  Allows the caller to manually dispatch `CoordinatorLayout.Behavior.onDependentViewChanged(CoordinatorLayout, View, View)` to the associated `CoordinatorLayout.Behavior` instances of views which depend on the provided `View`.
  `boolean`
  `doViewsOverlap(View first, View second)`
  Check whether two views overlap each other.
  `protected void`
  `drawChild(Canvas canvas, View child, long drawingTime)`
  Draw one child of this View Group.
  `protected CoordinatorLayout.LayoutParams`
  `generateDefaultLayoutParams()`
  Returns a set of default layout parameters.
  `protected CoordinatorLayout.LayoutParams`
  `generateLayoutParams(ViewGroup.LayoutParams p)`
  Returns a safe set of layout parameters based on the supplied layout params.
  `List<View>`
  `getDependencies(View child)`
  Returns a new list containing the views on which the provided view depends.
  `final @UnmodifiableView List<View>`
  `getDependencySortedChildren()`
  `List<View>`
  `getDependents(View child)`
  Returns a new list of views which depend on the provided view.
  `protected int`
  `getSuggestedMinimumHeight()`
  Returns the suggested minimum height that the view should use.
  `protected int`
  `getSuggestedMinimumWidth()`
  Returns the suggested minimum width that the view should use.
  `boolean`
  `isPointInChildBounds(View child, int x, int y)`
  Check if a given point in the CoordinatorLayout's coordinates are within the view bounds of the given direct child view.
  `void`
  `onAttachedToWindow()`
  This is called when the view is attached to a window.
  `void`
  `onDetachedFromWindow()`
  This is called when the view is detached from a window.
  `boolean`
  `onInterceptTouchEvent(MotionEvent ev)`
  Implement this method to intercept all touch screen motion events.
  `protected void`
  `onLayout(boolean changed, int l, int t, int r, int b)`
  Called from `View.layout(int, int, int, int)` when this view should assign a size and position to each of its children.
  `void`
  `onLayoutChild(View child, int layoutDirection)`
  Called to lay out each individual child view unless a `Behavior` is present.
  `protected void`
  `onMeasure(int widthMeasureSpec, int heightMeasureSpec)`
  Measure the view and its content to determine the measured width and the measured height.
  `void`
  `onMeasureChild(View child, int parentWidthMeasureSpec, int widthUsed, int parentHeightMeasureSpec, int heightUsed)`
  Called to measure each individual child view unless a `Behavior` is present.
  `boolean`
  `onNestedFling(View target, float velocityX, float velocityY, boolean consumed)`
  Request a fling from a nested scroll.
  `boolean`
  `onNestedPreFling(View target, float velocityX, float velocityY)`
  React to a nested fling before the target view consumes it.
  `void`
  `onNestedPreScroll(View target, int dx, int dy, int[] consumed, int type)`
  React to a nested scroll in progress before the target view consumes a portion of the scroll.
  `void`
  `onNestedScroll(View target, int dxConsumed, int dyConsumed, int dxUnconsumed, int dyUnconsumed, int type, int[] consumed)`
  React to a nested scroll in progress.
  `void`
  `onNestedScrollAccepted(View child, View target, int axes, int type)`
  React to the successful claiming of a nested scroll operation.
  `boolean`
  `onStartNestedScroll(View child, View target, int axes, int type)`
  React to a descendant view initiating a nestable scroll operation, claiming the nested scroll operation if appropriate.
  `void`
  `onStopNestedScroll(View target, int type)`
  React to a nested scroll operation ending.
  `boolean`
  `onTouchEvent(MotionEvent ev)`
  Implement this method to handle touch screen motion events.
  `protected void`
  `onViewRemoved(View child)`
  Called when a child view is removed from this ViewGroup.
  `boolean`
  `requestChildRectangleOnScreen(View child, Rect rectangle, boolean immediate)`
  Called when a child of this group wants a particular rectangle to be positioned onto the screen.
  `void`
  `requestDisallowInterceptTouchEvent(boolean disallowIntercept)`
  Called when a child does not want this parent and its ancestors to intercept touch events with `ViewGroup.onInterceptTouchEvent(MotionEvent)`.

  ### Methods inherited from class icyllis.modernui.view.ViewGroup

  `addFocusables, addKeyboardNavigationClusters, addStatesFromChildren, addTouchables, addTransientView, addView, addView, addView, addView, addView, addViewInLayout, addViewInLayout, attachViewToParent, bringChildToFront, childDrawableStateChanged, childHasTransientStateChanged, cleanupLayoutState, clearChildFocus, clearDisappearingChildren, clearFocus, detachAllViewsFromParent, detachViewFromParent, detachViewFromParent, detachViewsFromParent, dispatchDraw, dispatchDrawableHotspotChanged, dispatchFinishTemporaryDetach, dispatchGenericPointerEvent, dispatchHoverEvent, dispatchKeyEvent, dispatchKeyShortcutEvent, dispatchSetActivated, dispatchSetPressed, dispatchSetSelected, dispatchStartTemporaryDetach, dispatchTouchEvent, dispatchVisibilityChanged, dispatchWindowFocusChanged, dispatchWindowVisibilityChanged, drawableStateChanged, endViewTransition, findFocus, findViewByPredicateTraversal, findViewTraversal, focusableViewAvailable, focusSearch, getChildAt, getChildCount, getChildDrawingOrder, getChildDrawingOrder, getChildMeasureSpec, getChildVisibleRect, getChildVisibleRect, getClipChildren, getClipToPadding, getDescendantFocusability, getFocusedChild, getLayoutTransition, getNestedScrollAxes, getTouchscreenBlocksFocus, getTransientView, getTransientViewCount, getTransientViewIndex, hasBooleanFlag, hasFocus, hasTransientState, indexOfChild, internalSetPadding, isChildrenDrawingOrderEnabled, isLayoutSuppressed, isTransitionGroup, jumpDrawablesToCurrentState, layout, measureChild, measureChildren, measureChildWithMargins, offsetChildrenTopAndBottom, offsetDescendantRectToMyCoords, offsetRectIntoDescendantCoords, onChildVisibilityChanged, onCreateDrawableState, onInterceptHoverEvent, onRequestFocusInDescendants, onResolvePointerIcon, onSetLayoutParams, onViewAdded, removeAllViews, removeAllViewsInLayout, removeDetachedView, removeTransientView, removeView, removeViewAt, removeViewInLayout, removeViews, removeViewsInLayout, requestChildFocus, requestFocus, requestTransitionStart, resetResolvedDrawables, resolveDrawables, resolveLayoutDirection, resolveLayoutParams, resolvePadding, resolveRtlPropertiesIfNeeded, resolveTextAlignment, resolveTextDirection, restoreDefaultFocus, setAddStatesFromChildren, setBooleanFlag, setChildrenDrawingOrderEnabled, setClipChildren, setClipToPadding, setDescendantFocusability, setLayoutTransition, setTouchscreenBlocksFocus, setTransitionGroup, shouldDelayChildPressedState, showContextMenuForChild, startActionModeForChild, startViewTransition, suppressLayout, transformPointToViewLocal, updateViewLayout`

  ### Methods inherited from class icyllis.modernui.view.View

  `addFocusables, addOnAttachStateChangeListener, addOnLayoutChangeListener, awakenScrollBars, awakenScrollBars, callOnClick, cancelLongPress, cancelPendingInputEvents, canReceivePointerEvents, canResolveLayoutDirection, canResolveTextAlignment, canResolveTextDirection, canScrollHorizontally, canScrollVertically, combineMeasuredStates, computeHorizontalScrollExtent, computeHorizontalScrollOffset, computeHorizontalScrollRange, computeScroll, computeVerticalScrollExtent, computeVerticalScrollOffset, computeVerticalScrollRange, createContextMenu, dispatchGenericMotionEvent, dispatchNestedFling, dispatchNestedPreFling, dispatchNestedPreScroll, dispatchNestedScroll, dispatchPointerEvent, dp, draw, drawableHotspotChanged, findViewById, findViewByPredicate, findViewByPredicateInsideOut, focusSearch, forceHasOverlappingRendering, forceLayout, generateViewId, getAlpha, getAnimationMatrix, getBackground, getBaseline, getBottom, getBoundsOnScreen, getBoundsOnScreen, getContext, getContextMenuInfo, getDefaultSize, getDrawableState, getDrawingRect, getElevation, getFadingEdge, getFadingEdgeLength, getFocusable, getFocusables, getFocusedRect, getForeground, getForegroundGravity, getGlobalVisibleRect, getGlobalVisibleRect, getHandler, getHasOverlappingRendering, getHeight, getHitRect, getHorizontalScrollbarHeight, getHorizontalScrollbarThumbDrawable, getHorizontalScrollbarTrackDrawable, getId, getInverseMatrix, getKeyDispatcherState, getLayoutDirection, getLayoutParams, getLeft, getLocalVisibleRect, getLocationInWindow, getLocationOnScreen, getMatrix, getMeasuredHeight, getMeasuredHeightAndState, getMeasuredState, getMeasuredWidth, getMeasuredWidthAndState, getMinimumHeight, getMinimumWidth, getNextClusterForwardId, getNextFocusDownId, getNextFocusForwardId, getNextFocusLeftId, getNextFocusRightId, getNextFocusUpId, getOnFocusChangeListener, getOnLongClickListener, getOverScrollMode, getPaddingBottom, getPaddingEnd, getPaddingLeft, getPaddingRight, getPaddingStart, getPaddingTop, getParent, getPivotX, getPivotY, getRawLayoutDirection, getRawTextAlignment, getRawTextDirection, getRevealOnFocusHint, getRight, getRootView, getRotation, getRotationX, getRotationY, getScaleX, getScaleY, getScrollBarDefaultDelayBeforeFade, getScrollBarFadeDuration, getScrollBarSize, getScrollBarStyle, getScrollIndicators, getScrollX, getScrollY, getStateListAnimator, getTag, getTextAlignment, getTextDirection, getTooltipText, getTooltipView, getTop, getTouchables, getTransitionAlpha, getTransitionName, getTranslationX, getTranslationY, getTranslationZ, getVerticalFadingEdgeLength, getVerticalScrollbarThumbDrawable, getVerticalScrollbarTrackDrawable, getVerticalScrollbarWidth, getViewRoot, getViewTreeObserver, getVisibility, getWidth, getWindowAttachCount, getWindowVisibility, getX, getY, getZ, handleScrollBarDragging, hasExplicitFocusable, hasFocusable, hasIdentityMatrix, hasNestedScrollingParent, hasOnClickListeners, hasOnLongClickListeners, hasOverlappingRendering, hasTranslationTransientState, hasWindowFocus, invalidate, invalidateDrawable, isActivated, isAttachedToWindow, isClickable, isContextClickable, isDuplicateParentStateEnabled, isEnabled, isFocusable, isFocusableInTouchMode, isFocused, isFocusedByDefault, isForegroundInsidePadding, isHapticFeedbackEnabled, isHorizontalFadingEdgeEnabled, isHorizontalScrollBarEnabled, isHovered, isInLayout, isInScrollingContainer, isInTouchMode, isKeyboardNavigationCluster, isLaidOut, isLayoutDirectionInherited, isLayoutDirectionResolved, isLayoutRequested, isLayoutRtl, isLongClickable, isNestedScrollingEnabled, isPaddingRelative, isPivotSet, isPressed, isRootNamespace, isScrollbarFadingEnabled, isSelected, isShowingLayoutBounds, isShown, isSoundEffectsEnabled, isTemporarilyDetached, isTextAlignmentInherited, isTextAlignmentResolved, isTextDirectionInherited, isTextDirectionResolved, isVerticalFadingEdgeEnabled, isVerticalScrollBarEnabled, isVerticalScrollBarHidden, keyboardNavigationClusterSearch, mapRectFromViewToScreenCoords, measure, mergeDrawableStates, offsetLeftAndRight, offsetTopAndBottom, onCancelPendingInputEvents, onCreateContextMenu, onDragEvent, onDraw, onDrawForeground, onDrawScrollBars, onFinishTemporaryDetach, onFocusChanged, onGenericMotionEvent, onHoverChanged, onHoverEvent, onKeyDown, onKeyShortcut, onKeyUp, onOverScrolled, onResolveDrawables, onRtlPropertiesChanged, onScrollChanged, onSizeChanged, onStartTemporaryDetach, onVisibilityAggregated, onVisibilityChanged, onWindowFocusChanged, onWindowVisibilityChanged, overScrollBy, performButtonActionOnTouchDown, performClick, performContextClick, performContextClick, performHapticFeedback, performHapticFeedback, performLongClick, performLongClick, playSoundEffect, pointInView, post, postDelayed, postInvalidate, postInvalidateDelayed, postInvalidateOnAnimation, postOnAnimation, postOnAnimationDelayed, refreshDrawableState, removeCallbacks, removeOnAttachStateChangeListener, removeOnLayoutChangeListener, requestFocus, requestFocus, requestLayout, requestRectangleOnScreen, requestRectangleOnScreen, requireViewById, resetPivot, resolveSize, resolveSizeAndState, scheduleDrawable, scrollBy, scrollTo, setActivated, setAlpha, setAnimationMatrix, setBackground, setBottom, setClickable, setContextClickable, setDuplicateParentStateEnabled, setElevation, setEnabled, setFocusable, setFocusable, setFocusableInTouchMode, setFocusedByDefault, setFocusedInCluster, setForeground, setForegroundGravity, setFrame, setHapticFeedbackEnabled, setHasTransientState, setHasTranslationTransientState, setHorizontalFadingEdgeEnabled, setHorizontalScrollBarEnabled, setHorizontalScrollbarThumbDrawable, setHorizontalScrollbarTrackDrawable, setHovered, setId, setIsRootNamespace, setKeyboardNavigationCluster, setLayoutDirection, setLayoutParams, setLeft, setLongClickable, setMeasuredDimension, setMinimumHeight, setMinimumWidth, setNestedScrollingEnabled, setNextClusterForwardId, setNextFocusDownId, setNextFocusForwardId, setNextFocusLeftId, setNextFocusRightId, setNextFocusUpId, setOnClickListener, setOnContextClickListener, setOnCreateContextMenuListener, setOnDragListener, setOnFocusChangeListener, setOnGenericMotionListener, setOnHoverListener, setOnKeyListener, setOnLongClickListener, setOnScrollChangeListener, setOnTouchListener, setOverScrollMode, setPadding, setPaddingRelative, setPivotX, setPivotY, setPressed, setRevealOnFocusHint, setRight, setRotation, setRotationX, setRotationY, setScaleX, setScaleY, setScrollBarDefaultDelayBeforeFade, setScrollBarFadeDuration, setScrollbarFadingEnabled, setScrollBarSize, setScrollBarStyle, setScrollIndicators, setScrollIndicators, setScrollX, setScrollY, setSelected, setSoundEffectsEnabled, setStateListAnimator, setTag, setTextAlignment, setTextDirection, setTooltipText, setTop, setTransitionAlpha, setTransitionName, setTransitionVisibility, setTranslationX, setTranslationY, setTranslationZ, setVerticalFadingEdgeEnabled, setVerticalScrollBarEnabled, setVerticalScrollbarThumbDrawable, setVerticalScrollbarTrackDrawable, setVisibility, setWillNotDraw, setX, setY, setZ, showContextMenu, showContextMenu, sp, startActionMode, startActionMode, startDragAndDrop, startNestedScroll, stopNestedScroll, toGlobalMotionEvent, toLocalMotionEvent, toString, transformFromViewToWindowSpace, transformMatrixToGlobal, transformMatrixToLocal, unscheduleDrawable, unscheduleDrawable, verifyDrawable, willNotDraw`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface icyllis.modernui.view.ViewParent

  `canResolveLayoutDirection, canResolveTextAlignment, canResolveTextDirection, createContextMenu, getLayoutDirection, getParent, getTextAlignment, getTextDirection, isLayoutDirectionResolved, isLayoutRequested, isTextAlignmentResolved, isTextDirectionResolved, keyboardNavigationClusterSearch, requestLayout`

- ## Constructor Details

  - ### CoordinatorLayout

    public CoordinatorLayout(Context context)

- ## Method Details

  - ### onAttachedToWindow

    public void onAttachedToWindow()
    Description copied from class: `View`
    This is called when the view is attached to a window. At this point it has a Surface and will start drawing. Note that this function is guaranteed to be called before `View.onDraw(Canvas)`, however it may be called any time before the first onDraw -- including before or after `View.onMeasure(int, int)`.
    Overrides:
      `onAttachedToWindow` in class `View`
    See Also:
      - `View.onDetachedFromWindow()`

  - ### onDetachedFromWindow

    public void onDetachedFromWindow()
    Description copied from class: `View`
    This is called when the view is detached from a window. At this point it no longer has a surface for drawing.
    Overrides:
      `onDetachedFromWindow` in class `View`
    See Also:
      - `View.onAttachedToWindow()`

  - ### onInterceptTouchEvent

    public boolean onInterceptTouchEvent(@Nonnull MotionEvent ev)
    Description copied from class: `ViewGroup`
    Implement this method to intercept all touch screen motion events. This allows you to watch events as they are dispatched to your children, and take ownership of the current gesture at any point.

    Using this function takes some care, as it has a fairly complicated interaction with `View.onTouchEvent(MotionEvent)`, and using it requires implementing that method as well as this one in the correct way. Events will be received in the following order:

    1. You will receive the down event here.
    2. The down event will be handled either by a child of this view group, or given to your own onTouchEvent() method to handle; this means you should implement onTouchEvent() to return true, so you will continue to see the rest of the gesture (instead of looking for a parent view to handle it). Also, by returning true from onTouchEvent(), you will not receive any following events in onInterceptTouchEvent() and all touch processing must happen in onTouchEvent() like normal.
    3. For as long as you return false from this function, each following event (up to and including the final up) will be delivered first here and then to the target's onTouchEvent().
    4. If you return true from here, you will not receive any following events: the target view will receive the same event but with the action `MotionEvent.ACTION_CANCEL`, and all further events will be delivered to your onTouchEvent() method and no longer appear here.
    Overrides:
      `onInterceptTouchEvent` in class `ViewGroup`
    Parameters:
      `ev` - The motion event being dispatched down the hierarchy.
    Returns:
      Return true to steal motion events from the children and have them dispatched to this ViewGroup through onTouchEvent(). The current target will receive an ACTION_CANCEL event, and no further messages will be delivered here.

  - ### onTouchEvent

    public boolean onTouchEvent(@Nonnull MotionEvent ev)
    Description copied from class: `View`
    Implement this method to handle touch screen motion events.

    If this method is used to detect click actions, it is recommended that the actions be performed by implementing and calling `View.performClick()`. This will ensure consistent system behavior.

    Overrides:
      `onTouchEvent` in class `View`
    Parameters:
      `ev` - the touch event
    Returns:
      `true` if the event was handled by the view, `false` otherwise

  - ### requestDisallowInterceptTouchEvent

    public void requestDisallowInterceptTouchEvent(boolean disallowIntercept)
    Description copied from interface: `ViewParent`
    Called when a child does not want this parent and its ancestors to intercept touch events with `ViewGroup.onInterceptTouchEvent(MotionEvent)`.

    This parent should pass this call onto its parents. This parent must obey this request for the duration of the touch (that is, only clear the flag after this parent has received an up or a cancel.

    Specified by:
      `requestDisallowInterceptTouchEvent` in interface `ViewParent`
    Overrides:
      `requestDisallowInterceptTouchEvent` in class `ViewGroup`
    Parameters:
      `disallowIntercept` - True if the child does not want the parent to intercept touch events.

  - ### getSuggestedMinimumWidth

    protected int getSuggestedMinimumWidth()
    Description copied from class: `View`
    Returns the suggested minimum width that the view should use. This returns the maximum of the view's minimum width and the background's minimum width (`Drawable.getMinimumWidth()`).

    When being used in `View.onMeasure(int, int)`, the caller should still ensure the returned width is within the requirements of the parent.

    Overrides:
      `getSuggestedMinimumWidth` in class `View`
    Returns:
      The suggested minimum width of the view.

  - ### getSuggestedMinimumHeight

    protected int getSuggestedMinimumHeight()
    Description copied from class: `View`
    Returns the suggested minimum height that the view should use. This returns the maximum of the view's minimum height and the background's minimum height (`Drawable.getMinimumHeight()`).

    When being used in `View.onMeasure(int, int)`, the caller should still ensure the returned height is within the requirements of the parent.

    Overrides:
      `getSuggestedMinimumHeight` in class `View`
    Returns:
      The suggested minimum height of the view.

  - ### onMeasureChild

    public void onMeasureChild(View child, int parentWidthMeasureSpec, int widthUsed, int parentHeightMeasureSpec, int heightUsed)
    Called to measure each individual child view unless a `Behavior` is present. The Behavior may choose to delegate child measurement to this method.
    Parameters:
      `child` - the child to measure
      `parentWidthMeasureSpec` - the width requirements for this view
      `widthUsed` - extra space that has been used up by the parent horizontally (possibly by other children of the parent)
      `parentHeightMeasureSpec` - the height requirements for this view
      `heightUsed` - extra space that has been used up by the parent vertically (possibly by other children of the parent)

  - ### onMeasure

    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec)
    Description copied from class: `View`
    Measure the view and its content to determine the measured width and the measured height. This method is invoked by `View.measure(int, int)` and should be overridden by subclasses to provide accurate and efficient measurement of their contents.

    CONTRACT: When overriding this method, you must call `View.setMeasuredDimension(int, int)` to store the measured width and height of this view. Failure to do so will trigger an `IllegalStateException`, thrown by `View.measure(int, int)`. Calling super.onMeasure() is a valid use.

    The base class implementation of measure defaults to the background size, unless a larger size is allowed by the MeasureSpec. Subclasses should override the base one to provide better measurements of their content.

    Overrides:
      `onMeasure` in class `View`
    Parameters:
      `widthMeasureSpec` - width measure specification imposed by the parent `MeasureSpec`
      `heightMeasureSpec` - height measure specification imposed by the parent `MeasureSpec`

  - ### onLayoutChild

    public void onLayoutChild(@Nonnull View child, int layoutDirection)
    Called to lay out each individual child view unless a `Behavior` is present. The Behavior may choose to delegate child measurement to this method.
    Parameters:
      `child` - child view to lay out
      `layoutDirection` - the resolved layout direction for the CoordinatorLayout, such as `View.LAYOUT_DIRECTION_LTR` or `View.LAYOUT_DIRECTION_RTL`.

  - ### onLayout

    protected void onLayout(boolean changed, int l, int t, int r, int b)
    Description copied from class: `View`
    Called from `View.layout(int, int, int, int)` when this view should assign a size and position to each of its children.

    Derived classes with children should override this method and call layout on each of their children.

    Specified by:
      `onLayout` in class `ViewGroup`
    Parameters:
      `changed` - This is a new size or position for this view
      `l` - Left position, relative to parent
      `t` - Top position, relative to parent
      `r` - Right position, relative to parent
      `b` - Bottom position, relative to parent

  - ### drawChild

    protected void drawChild(@Nonnull Canvas canvas, @Nonnull View child, long drawingTime)
    Description copied from class: `ViewGroup`
    Draw one child of this View Group. This method is responsible for getting the canvas in the right state. This includes clipping, translating so that the child's scrolled origin is at 0, 0, and applying any animation transformations.
    Overrides:
      `drawChild` in class `ViewGroup`
    Parameters:
      `canvas` - The canvas on which to draw the child
      `child` - Who to draw
      `drawingTime` - The time at which draw is occurring

  - ### dispatchDependentViewsChanged

    public void dispatchDependentViewsChanged(@Nonnull View view)
    Allows the caller to manually dispatch `CoordinatorLayout.Behavior.onDependentViewChanged(CoordinatorLayout, View, View)` to the associated `CoordinatorLayout.Behavior` instances of views which depend on the provided `View`.

    You should not normally need to call this method as the it will be automatically done when the view has changed.

    Parameters:
      `view` - the View to find dependents of to dispatch the call.

  - ### getDependencies

    @Nonnull public List<View> getDependencies(@Nonnull View child)
    Returns a new list containing the views on which the provided view depends.
    Parameters:
      `child` - the view to find dependencies for
    Returns:
      a new list of views on which `child` depends

  - ### getDependents

    @Nonnull public List<View> getDependents(@Nonnull View child)
    Returns a new list of views which depend on the provided view.
    Parameters:
      `child` - the view to find dependents of
    Returns:
      a new list of views which depend on `child`

  - ### getDependencySortedChildren

    @Nonnull @VisibleForTesting public final @UnmodifiableView List<View> getDependencySortedChildren()

  - ### isPointInChildBounds

    public boolean isPointInChildBounds(@Nonnull View child, int x, int y)
    Check if a given point in the CoordinatorLayout's coordinates are within the view bounds of the given direct child view.
    Parameters:
      `child` - child view to test
      `x` - X coordinate to test, in the CoordinatorLayout's coordinate system
      `y` - Y coordinate to test, in the CoordinatorLayout's coordinate system
    Returns:
      true if the point is within the child view's bounds, false otherwise

  - ### doViewsOverlap

    public boolean doViewsOverlap(@Nonnull View first, @Nonnull View second)
    Check whether two views overlap each other. The views need to be descendants of this `CoordinatorLayout` in the view hierarchy.
    Parameters:
      `first` - first child view to test
      `second` - second child view to test
    Returns:
      true if both views are visible and overlap each other

  - ### onViewRemoved

    protected void onViewRemoved(View child)
    Description copied from class: `ViewGroup`
    Called when a child view is removed from this ViewGroup. Overrides should always call super.onViewRemoved.
    Overrides:
      `onViewRemoved` in class `ViewGroup`
    Parameters:
      `child` - the removed child view

  - ### requestChildRectangleOnScreen

    public boolean requestChildRectangleOnScreen(@Nonnull View child, Rect rectangle, boolean immediate)
    Description copied from interface: `ViewParent`
    Called when a child of this group wants a particular rectangle to be positioned onto the screen. `ViewGroup`s overriding this can trust that:
    - child will be a direct child of this group
    - rectangle will be in the child's content coordinates

    `ViewGroup`s overriding this should uphold the contract:

    - nothing will change if the rectangle is already visible
    - the view port will be scrolled only just enough to make the rectangle visible
    Specified by:
      `requestChildRectangleOnScreen` in interface `ViewParent`
    Overrides:
      `requestChildRectangleOnScreen` in class `ViewGroup`
    Parameters:
      `child` - The direct child making the request.
      `rectangle` - The rectangle in the child's coordinates the child wishes to be on the screen.
      `immediate` - True to forbid animated or delayed scrolling, false otherwise
    Returns:
      Whether the group scrolled to handle the operation

  - ### generateLayoutParams

    @Nonnull protected CoordinatorLayout.LayoutParams generateLayoutParams(@Nonnull ViewGroup.LayoutParams p)
    Description copied from class: `ViewGroup`
    Returns a safe set of layout parameters based on the supplied layout params. When a ViewGroup is passed a View whose layout params do not pass the test of `ViewGroup.checkLayoutParams(LayoutParams)`, this method is invoked. This method should return a new set of layout params suitable for this ViewGroup, possibly by copying the appropriate attributes from the specified set of layout params.
    Overrides:
      `generateLayoutParams` in class `ViewGroup`
    Parameters:
      `p` - The layout parameters to convert into a suitable set of layout parameters for this ViewGroup.
    Returns:
      an instance of `ViewGroup.LayoutParams` or one of its descendants

  - ### generateDefaultLayoutParams

    @Nonnull protected CoordinatorLayout.LayoutParams generateDefaultLayoutParams()
    Description copied from class: `ViewGroup`
    Returns a set of default layout parameters. These parameters are requested when the View passed to `ViewGroup.addView(View)` has no layout parameters already set. If null is returned, an exception is thrown from addView.
    Overrides:
      `generateDefaultLayoutParams` in class `ViewGroup`
    Returns:
      a set of default layout parameters

  - ### checkLayoutParams

    protected boolean checkLayoutParams(ViewGroup.LayoutParams p)
    Description copied from class: `ViewGroup`
    Check whether given params fit to this view group.

    See also `ViewGroup.generateLayoutParams(LayoutParams)` See also `ViewGroup.generateDefaultLayoutParams()`

    Overrides:
      `checkLayoutParams` in class `ViewGroup`
    Parameters:
      `p` - layout params to check
    Returns:
      if params matched to this view group

  - ### onStartNestedScroll

    public boolean onStartNestedScroll(@Nonnull View child, @Nonnull View target, int axes, int type)
    Description copied from interface: `ViewParent`
    React to a descendant view initiating a nestable scroll operation, claiming the nested scroll operation if appropriate.

    This method will be called in response to a descendant view invoking `View.startNestedScroll(int, int)`. Each parent up the view hierarchy will be given an opportunity to respond and claim the nested scrolling operation by returning `true`.

    This method may be overridden by ViewParent implementations to indicate when the view is willing to support a nested scrolling operation that is about to begin. If it returns true, this ViewParent will become the target view's nested scrolling parent for the duration of the scroll operation in progress. When the nested scroll is finished this ViewParent will receive a call to `ViewParent.onStopNestedScroll(View, int)`.

    Specified by:
      `onStartNestedScroll` in interface `ViewParent`
    Overrides:
      `onStartNestedScroll` in class `ViewGroup`
    Parameters:
      `child` - Direct child of this ViewParent containing target
      `target` - View that initiated the nested scroll
      `axes` - Flags consisting of `View.SCROLL_AXIS_HORIZONTAL`, `View.SCROLL_AXIS_VERTICAL` or both
      `type` - the type of input which cause this scroll event
    Returns:
      true if this ViewParent accepts the nested scroll operation

  - ### onNestedScrollAccepted

    public void onNestedScrollAccepted(@Nonnull View child, @Nonnull View target, int axes, int type)
    Description copied from interface: `ViewParent`
    React to the successful claiming of a nested scroll operation.

    This method will be called after `onStartNestedScroll` returns true. It offers an opportunity for the view and its superclasses to perform initial configuration for the nested scroll. Implementations of this method should always call their superclasses' implementation of this method if one is present.

    Specified by:
      `onNestedScrollAccepted` in interface `ViewParent`
    Overrides:
      `onNestedScrollAccepted` in class `ViewGroup`
    Parameters:
      `child` - Direct child of this ViewParent containing target
      `target` - View that initiated the nested scroll
      `axes` - Flags consisting of `View.SCROLL_AXIS_HORIZONTAL`, `View.SCROLL_AXIS_VERTICAL` or both
      `type` - the type of input which cause this scroll event
    See Also:
      - `ViewParent.onStartNestedScroll(View, View, int, int)`
      - `ViewParent.onStopNestedScroll(View, int)`

  - ### onStopNestedScroll

    public void onStopNestedScroll(@Nonnull View target, int type)
    Description copied from interface: `ViewParent`
    React to a nested scroll operation ending.

    Perform cleanup after a nested scrolling operation. This method will be called when a nested scroll stops, for example when a nested touch scroll ends with a `MotionEvent.ACTION_UP` or `MotionEvent.ACTION_CANCEL` event. Implementations of this method should always call their superclasses' implementation of this method if one is present.

    Specified by:
      `onStopNestedScroll` in interface `ViewParent`
    Overrides:
      `onStopNestedScroll` in class `ViewGroup`
    Parameters:
      `target` - View that initiated the nested scroll
      `type` - the type of input which cause this scroll event

  - ### onNestedScroll

    public void onNestedScroll(@Nonnull View target, int dxConsumed, int dyConsumed, int dxUnconsumed, int dyUnconsumed, int type, @Nonnull int[] consumed)
    Description copied from interface: `ViewParent`
    React to a nested scroll in progress.

    This method will be called when the ViewParent's current nested scrolling child view dispatches a nested scroll event. To receive calls to this method the ViewParent must have previously returned `true` for a call to `ViewParent.onStartNestedScroll(View, View, int, int)`.

    Both the consumed and unconsumed portions of the scroll distance are reported to the ViewParent. An implementation may choose to use the consumed portion to match or chase scroll position of multiple child elements, for example. The unconsumed portion may be used to allow continuous dragging of multiple scrolling or draggable elements, such as scrolling a list within a vertical drawer where the drawer begins dragging once the edge of inner scrolling content is reached.

    This method is called when a nested scrolling child invokes `View.dispatchNestedScroll(int, int, int, int, int[], int, int[])`} or one of methods it overloads.

    An implementation must report how many pixels of the x and y scroll distances were consumed by this nested scrolling parent by adding the consumed distances to the `consumed` parameter. `consumed` should also be passed up to it's nested scrolling parent so that the parent may also add any scroll distance it consumes. Index 0 corresponds to dx and index 1 corresponds to dy.

    Specified by:
      `onNestedScroll` in interface `ViewParent`
    Overrides:
      `onNestedScroll` in class `ViewGroup`
    Parameters:
      `target` - The descendant view controlling the nested scroll
      `dxConsumed` - Horizontal scroll distance in pixels already consumed by target
      `dyConsumed` - Vertical scroll distance in pixels already consumed by target
      `dxUnconsumed` - Horizontal scroll distance in pixels not consumed by target
      `dyUnconsumed` - Vertical scroll distance in pixels not consumed by target
      `type` - the type of input which cause this scroll event
      `consumed` - Output. Upon this method returning, will contain the scroll distances consumed by this nested scrolling parent and the scroll distances consumed by any other parent up the view hierarchy
    See Also:
      - `View.dispatchNestedScroll(int, int, int, int, int[], int, int[])`

  - ### onNestedPreScroll

    public void onNestedPreScroll(@Nonnull View target, int dx, int dy, @Nonnull int[] consumed, int type)
    Description copied from interface: `ViewParent`
    React to a nested scroll in progress before the target view consumes a portion of the scroll.

    When working with nested scrolling often the parent view may want an opportunity to consume the scroll before the nested scrolling child does. An example of this is a drawer that contains a scrollable list. The user will want to be able to scroll the list fully into view before the list itself begins scrolling.

    `onNestedPreScroll` is called when a nested scrolling child invokes `View.dispatchNestedPreScroll(int, int, int[], int[], int)`. The implementation should report how any pixels of the scroll reported by dx, dy were consumed in the `consumed` array. Index 0 corresponds to dx and index 1 corresponds to dy. This parameter will never be null. Initial values for consumed[0] and consumed[1] will always be 0.

    Specified by:
      `onNestedPreScroll` in interface `ViewParent`
    Overrides:
      `onNestedPreScroll` in class `ViewGroup`
    Parameters:
      `target` - View that initiated the nested scroll
      `dx` - Horizontal scroll distance in pixels
      `dy` - Vertical scroll distance in pixels
      `consumed` - Output. The horizontal and vertical scroll distance consumed by this parent
      `type` - the type of input which cause this scroll event

  - ### onNestedFling

    public boolean onNestedFling(@Nonnull View target, float velocityX, float velocityY, boolean consumed)
    Description copied from interface: `ViewParent`
    Request a fling from a nested scroll.

    This method signifies that a nested scrolling child has detected suitable conditions for a fling. Generally this means that a touch scroll has ended with a `velocity` in the direction of scrolling that meets or exceeds the `minimum fling velocity` along a scrollable axis.

    If a nested scrolling child view would normally fling but it is at the edge of its own content, it can use this method to delegate the fling to its nested scrolling parent instead. The parent may optionally consume the fling or observe a child fling.

    Specified by:
      `onNestedFling` in interface `ViewParent`
    Overrides:
      `onNestedFling` in class `ViewGroup`
    Parameters:
      `target` - View that initiated the nested scroll
      `velocityX` - Horizontal velocity in pixels per second
      `velocityY` - Vertical velocity in pixels per second
      `consumed` - true if the child consumed the fling, false otherwise
    Returns:
      true if this parent consumed or otherwise reacted to the fling

  - ### onNestedPreFling

    public boolean onNestedPreFling(@Nonnull View target, float velocityX, float velocityY)
    Description copied from interface: `ViewParent`
    React to a nested fling before the target view consumes it.

    This method signifies that a nested scrolling child has detected a fling with the given velocity along each axis. Generally this means that a touch scroll has ended with a `velocity` in the direction of scrolling that meets or exceeds the `minimum fling velocity` along a scrollable axis.

    If a nested scrolling parent is consuming motion as part of a `pre-scroll`, it may be appropriate for it to also consume the pre-fling to complete that same motion. By returning `true` from this method, the parent indicates that the child should not fling its own internal content as well.

    Specified by:
      `onNestedPreFling` in interface `ViewParent`
    Overrides:
      `onNestedPreFling` in class `ViewGroup`
    Parameters:
      `target` - View that initiated the nested scroll
      `velocityX` - Horizontal velocity in pixels per second
      `velocityY` - Vertical velocity in pixels per second
    Returns:
      true if this parent consumed the fling ahead of the target view